︠5a9f35a9-3b2e-4db1-85ef-b6e218300beei︠
%html
<h1 style="text-align: center;">581d - 2010-10-14:</h1>
<h2 style="text-align: center;">A Crash course in Python, for people who (think they) know Python.</h2>
<h2 style="text-align: center;">Today: Functions and Classes</h2>
<p>NOTE: This worksheet should be run in Python mode. &nbsp;Adjust the dropdown at the top of the worksheet to make sure it is in that mode.</p>

︡7a83cf3b-6989-4715-bee6-030ba4168fd7︡{"html": "<h1 style=\"text-align: center;\">581d - 2010-10-14:</h1>\n<h2 style=\"text-align: center;\">A Crash course in Python, for people who (think they) know Python.</h2>\n<h2 style=\"text-align: center;\">Today: Functions and Classes</h2>\n<p>NOTE: This worksheet should be run in Python mode. &nbsp;Adjust the dropdown at the top of the worksheet to make sure it is in that mode.</p>"}︡
︠bfd45c95-8013-4c44-8a7f-a8d2f9668157i︠
%html
<h1>Functions</h1>
<p>A big gotcha (explain):</p>

︡718dad6b-736e-4e8b-9b96-248e2d8b6582︡{"html": "<h1>Functions</h1>\n<p>A big gotcha (explain):</p>"}︡
︠233549eb-6e9b-4b47-a4cc-72384ce0f7eb︠
def f(a, L=[]):
    L.append(a)
    print L

f(1)
f(2)
f(3)
︡3eaa842a-e659-4d72-a2a9-617efa788169︡{"stdout": "[1]\n[1, 2]\n[1, 2, 3]"}︡
︠ee18ad04-fb8e-4467-b863-7d3d9931438di︠
%html
<p>Right thing to do is this:</p>

︡dba8019c-b666-46ec-b34a-5f10751b752e︡{"html": "<p>Right thing to do is this:</p>"}︡
︠a348d3a0-d0a9-4c94-a640-15d4e8adb321︠
def f(a, L=None):
    if L is None: L = []
    L.append(a)
    print L

f(1)
f(2)
f(3)
︡38c36ea4-6886-48a0-8656-88c72fbc6939︡{"stdout": "[1]\n[2]\n[3]"}︡
︠d4e4df5c-5915-472b-9f10-46fd990e5e5ei︠
%html
<p>How to do variable number of arguments and keywords:</p>

︡e1f3f9a9-7d53-469d-b772-feb732410600︡{"html": "<p>How to do variable number of arguments and keywords:</p>"}︡
︠af70e17c-81c1-49ce-bcd5-8a3e0dd6221f︠
def f(a, b, *args, **kwds):
    print a, b
    print "args = ", args
    print "kwds = ", kwds
︡c9734d8e-d62d-4148-8057-a5faba41e6fa︡︡
︠27e81ac4-85bf-4795-bd51-09b5d415db05︠
f(2,3, 10, x=5, yz=20)
︡ee12e7f0-658b-4177-9e2d-e41127b23096︡{"stdout": "2 3\nargs =  (10,)\nkwds =  {'x': 5, 'yz': 20}"}︡
︠767d9676-3ba5-436b-8e01-030d339c5d40i︠
%html
<p>You can magically turn a tuple or dictionary into the inputs to a function using * and **:</p>

︡330cb317-497e-4a44-804a-8aac595603be︡{"html": "<p>You can magically turn a tuple or dictionary into the inputs to a function using * and **:</p>"}︡
︠2c55c7c6-a738-48cd-bb0e-a4fe1c0d3f23︠
def f(a, b, xyz):
    print "a = ", a
    print "b = ", b
    print "xyz = ", xyz
︡4a445255-1e62-470d-9cb8-566e348d9116︡︡
︠39103962-9da3-4581-b0aa-e68aa2625128︠
f(3,4, 'hello')
︡9e230cc8-1ed6-4db5-8b9a-ffd5321ef907︡{"stdout": "a =  3\nb =  4\nxyz =  hello"}︡
︠7d1a63b9-8729-4228-bcfd-f24211ac70a3︠
v = (3,4)
d = {'xyz':'hello'}
f(*v, **d)
︡09e91618-e2b9-4177-bd62-4fa81781cad9︡{"stdout": "a =  3\nb =  4\nxyz =  hello"}︡
︠b78b270c-2b7f-47c0-ba27-ba9aa0b89e1fi︠
%html
<p>When you explicitly specify the input variable names, you can give them in any order:</p>

︡92cfcab3-d453-4770-a510-58f22b97af9b︡{"html": "<p>When you explicitly specify the input variable names, you can give them in any order:</p>"}︡
︠d2ee0f7d-2835-411a-b6d7-5f17e6bcba8a︠
def f(a, b):
    print "a =", a
    print "b =", b
︡e01dd5fa-af03-4e51-8b93-7639618d8ea7︡︡
︠a884bda7-ecbb-4538-8b69-bb8535260ab4︠
f(b=20, a=7)
︡4b3c4fe0-1b48-40c7-a7c8-3a7c9e38cddd︡{"stdout": "a = 7\nb = 20"}︡
︠7e43215d-d3ce-4e28-a530-7101c466c793︠
f(7, 20)
︡351da00b-4258-4fe8-924e-b8eb6bd4bad7︡{"stdout": "a = 7\nb = 20"}︡
︠421623c1-e0c9-4f1c-8cdc-ee9d31482ad6︠
f(a=7, b=20)
︡6988d10b-9b85-40e8-af41-cd63aa3b3bc7︡{"stdout": "a = 7\nb = 20"}︡
︠97c568d7-64ef-47eb-abcb-7e0ae9eb5b51i︠
%html
<p>A function can sometimes tell whether it was called with the input variable explicitly specified via a keyword or not. &nbsp;So there is a difference between f(7,20) and f(a=7,b=20).</p>

︡21d6bb25-c3fa-4260-b0d5-b7a5798861dd︡{"html": "<p>A function can sometimes tell whether it was called with the input variable explicitly specified via a keyword or not. &nbsp;So there is a difference between f(7,20) and f(a=7,b=20).</p>"}︡
︠11ec5f52-1e4b-4109-b3e3-47b5fcfbfe05︠
def f(*args, **kwds):
    if len(kwds) > 0: 
        print "a keyword was used in calling me"
    else: print "no keywords used"
︡059d31f3-df7d-45ac-b698-9ecee1324459︡︡
︠126df6e0-ef7f-466e-ae46-e988ac2554b7︠
f(7,20)
︡10cca605-d1b7-432b-86ef-ab017b0ed457︡{"stdout": "no keywords used"}︡
︠c8da1f89-1bb3-404f-bc8f-845d10bc50da︠
f(a=7,b=20)
︡ba59873f-e447-43a0-afe1-eca505c7d36d︡{"stdout": "a keyword was used in calling me"}︡
︠0b5555c9-1f73-493c-9b90-d2d9f2de2638i︠
%html
<p>How to return multiple values.</p>

︡95dcae77-9866-475a-9374-cbcc740b9915︡{"html": "<p>How to return multiple values.</p>"}︡
︠b4962dba-8b1a-467d-9988-afb403d7c52d︠
def f(n):
    return n^2, n^3
︡d8c53a96-3e45-4dab-b919-5cc3975c3168︡︡
︠871a5f04-1cf7-4b2e-94f5-b20120aaf229︠
a, b = f(10)
print "a =", a
print "b =", b
︡9e46adc4-b5f6-40d0-bae2-0ff2895e9c7d︡{"stdout": "a = 8\nb = 9"}︡
︠6705ea51-6be4-4b1a-9499-94755c7c6075i︠
%html
<p>This actually looks exactly like what you do in Magma, but it is much different (and better) than Magma, since really a tuple is returned, and Python does tuple unpacking:</p>

︡b4211a19-f847-4f83-b3f3-ccfdb061ef78︡{"html": "<p>This actually looks exactly like what you do in Magma, but it is much different (and better) than Magma, since really a tuple is returned, and Python does tuple unpacking:</p>"}︡
︠3a335042-8686-4944-b7ba-5cd85769bb1a︠
t = f(10); t
︡d75c9756-e693-491e-9922-1aaabd8ab71e︡{"stdout": "(8, 9)"}︡
︠7db84087-a49f-4bb0-819b-e550084eb372︠
type(t)
︡0051517b-963c-4a20-8c90-8a61dc2500ef︡{"stdout": "<type 'tuple'>"}︡
︠037d3e55-f79b-4b61-b609-b07366bad2c9︠
a, b = t
print a, b
︡bd061fe1-9254-4d3c-a9cc-00084ba0dbc6︡{"stdout": "8 9"}︡
︠2c3346f1-474c-4204-9041-a6f27e87308ei︠
%html
<p>Python functions can be easily passed around, and you can figure out some things about them in some cases.</p>

︡61bbdbfe-558b-4678-8a3c-f5ba94faeb96︡{"html": "<p>Python functions can be easily passed around, and you can figure out some things about them in some cases.</p>"}︡
︠a0a880d4-3b8a-42e3-bb18-8b5231c01cb4︠
def f(op, a, b):
    return op(a,b)
︡b4b791ed-032a-4f02-9fbf-6ea29594cbaf︡︡
︠446604bf-2056-4aeb-b5eb-174cdcf0027a︠
def my_op(a, b):
    return a*b
︡07e614b6-f79f-4d1f-b68c-acd49e541b47︡︡
︠547dc025-ecfc-40f9-9778-3898bc68977b︠
f(my_op, 4, 5)
︡55e807db-c9da-4626-92c1-154978839d82︡{"stdout": "20"}︡
︠d310f33c-3de3-4452-af9f-a1dbcadc420e︠
my_op.func_name
︡ba023a0b-7beb-4af8-b96b-dc9d8e8c6adf︡{"stdout": "'my_op'"}︡
︠28120166-1a5a-4e77-ad2e-5e51b87f3463i︠
%html
<p>You can attach extra <em>attributes</em> to a function itself. &nbsp;(This only works with functions defined in Python.)</p>

︡c6e752d3-c290-4f94-8476-395524a0726d︡{"html": "<p>You can attach extra <em>attributes</em> to a function itself. &nbsp;(This only works with functions defined in Python.)</p>"}︡
︠a9049a74-f9b2-412b-baa3-5dedc7721a69︠
def f(n, m):
    return f.op(n,m)
︡4108b2d5-c62d-4215-a3b1-eccf85e420aa︡︡
︠a2a06d3a-6c61-41f5-a452-178bf47177a9︠
f.op = lambda a,b: a*b +1
︡cbbbd1fc-7764-4414-ac84-024eddc0b089︡︡
︠6db40781-90d2-4440-98b5-5da74f1313f1︠
f(3,8)
︡059e4c59-cfe6-4dd3-be5c-4e015a4ab0a3︡{"stdout": "25"}︡
︠f685c500-3cca-455e-906e-9a2e5c101c87︠
f.op
︡49d6eb34-d20c-4a5e-8b05-91234fded169︡{"stdout": "<function <lambda> at 0x10ca42398>"}︡
︠2739e279-749a-4c51-8963-f9ba7a40e04bi︠
%html
<p>You can't attach attributes to functions that are "builtin".</p>

︡937a5cb1-8f47-4417-a98b-872b4e376ee2︡{"html": "<p>You can't attach attributes to functions that are \"builtin\".</p>"}︡
︠2c60e96f-49ee-4b2b-87b2-f860636baccb︠
print type(f)

import math
print type(math.sin)
︡0f7ca5ba-dd04-4590-affb-492d010c0ed2︡{"stdout": "<type 'function'>\n<type 'builtin_function_or_method'>"}︡
︠8dbb038c-cb8f-4936-9657-319132d84a40︠
math.sin.op = 5
︡9e317699-e56f-4fd2-a6a4-9c22018cc3aa︡{"stderr": "Traceback (most recent call last):\n  File \"<stdin>\", line 1, in <module>\n  File \"_sage_input_56.py\", line 10, in <module>\n    exec compile(u\"print _support_.syseval(python, u'math.sin.op = 5', __SAGE_TMP_DIR__)\" + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"/Users/wstein/sage/install/sage-4.5.3/local/lib/python2.6/site-packages/sagenb-0.8.2-py2.6.egg/sagenb/misc/support.py\", line 473, in syseval\n    return system.eval(cmd, sage_globals, locals = sage_globals)\n  File \"/Users/wstein/sage/install/sage-4.5.3/local/lib/python2.6/site-packages/sage/misc/python.py\", line 56, in eval\n    eval(z, globals)\n  File \"\", line 1, in <module>\n    \nAttributeError: 'builtin_function_or_method' object has no attribute 'op'"}︡
︠263f9798-55cf-42d4-a4c5-d9e8b9c625b3i︠
%html
<p>Another gotcha is recursion, which <strong><em>does not scale</em></strong> in Python.&nbsp;</p>

︡51b7b8a2-2217-4eee-9926-fa8a9448999d︡{"html": "<p>Another gotcha is recursion, which <strong><em>does not scale</em></strong> in Python.&nbsp;</p>"}︡
︠6c8a6984-c9ab-4789-ad44-63ab37706283︠
def myfactorial(n):
    if n == 1: return n
    assert n > 0
    return n * myfactorial(n-1)
︡67835652-ea7b-45ca-a83d-6bc89059b6c4︡︡
︠e533d3db-87ae-4062-ac62-01ac1d11360f︠
myfactorial(69)
︡9bfe2577-8b72-45c7-88db-b284fc3271db︡{"stdout": "171122452428141311372468338881272839092270544893520369393648040923257279754140647424000000000000000L"}︡
︠5764c04f-e547-4b6c-815f-ed23665cc4b8︠
a = myfactorial(994)
len(str(a))
︡41042c73-012b-4c61-ba31-6b09bbd5ca2e︡{"stdout": "2550"}︡
︠3f7cf6a1-e499-4e6d-a9ad-c126b1c52e04︠
myfactorial(995)
︡58c79a9e-f53d-4f28-94e0-249cae421a76︡{"stdout": "WARNING: Output truncated!"}︡{"html": "<a target='_new' href='/home/admin/517/cells/52/full_output.txt' class='file_link'>full_output.txt</a>"}︡{"stderr": "Traceback (most recent call last):\n  File \"<stdin>\", line 1, in <module>\n  File \"_sage_input_72.py\", line 10, in <module>\n    exec compile(u\"print _support_.syseval(python, u'myfactorial(995)', __SAGE_TMP_DIR__)\" + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"/Users/wstein/sage/install/sage-4.5.3/local/lib/python2.6/site-packages/sagenb-0.8.2-py2.6.egg/sagenb/misc/support.py\", line 473, in syseval\n    return system.eval(cmd, sage_globals, locals = sage_globals)\n  File \"/Users/wstein/sage/install/sage-4.5.3/local/lib/python2.6/site-packages/sage/misc/python.py\", line 56, in eval\n    eval(z, globals)\n  File \"\", line 1, in <module>\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n\n...\n\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \n  File \"\", line 5, in myfactorial\n    \nRuntimeError: maximum recursion depth exceeded"}︡
︠1dca7912-bb87-4759-89f7-298becc84313i︠
%html
<p>So watch out and be careful when writing recursive functions that you only use them when the depth of the recursion is bounded by 1000. &nbsp;Or, simply increase the recursionlimit as illustrarted below.&nbsp;</p>

︡1c933ae3-3412-4320-a027-1e4b6bd04e58︡{"html": "<p>So watch out and be careful when writing recursive functions that you only use them when the depth of the recursion is bounded by 1000. &nbsp;Or, simply increase the recursionlimit as illustrarted below.&nbsp;</p>"}︡
︠ae35b437-ae06-47b0-b287-aaa74aeea0f7︠
import sys
sys.getrecursionlimit()
︡18971c72-7f0d-4e5b-9795-37279abf08b1︡{"stdout": "1000"}︡
︠423f7f2d-e02c-4ca9-b588-8484fc39d6eb︠
sys.setrecursionlimit(10000)
︡a5b3be5d-f12e-417f-9595-621ee77e8ff4︡︡
︠342a4515-aef8-4b73-8745-12eb07f6c104︠
a = myfactorial(2000)
︡f7fc4539-f079-40ed-8f8c-12b06caa7ea3︡︡
︠7567456c-559a-4945-bbc0-ebfacefa8e24i︠
%html
<p>Style: Go through <a href="http://docs.python.org/tutorial/controlflow.html#intermezzo-coding-style" target="_blank">http://docs.python.org/tutorial/controlflow.html#intermezzo-coding-style</a></p>
<p>The following function illustrates all the points.</p>

︡597cabe8-cdaa-46b4-b436-436810c71f82︡{"html": "<p>Style: Go through <a href=\"http://docs.python.org/tutorial/controlflow.html#intermezzo-coding-style\" target=\"_blank\">http://docs.python.org/tutorial/controlflow.html#intermezzo-coding-style</a></p>\n<p>The following function illustrates all the points.</p>"}︡
︠9c1f32ff-e27a-47cb-adbe-0b15af7842ed︠
def good_function(a, b = 10):
    """
    This is a good function.  
    
    This function has a docstring and is named 
    using lower_case_with_underscores.
    
    It takes as input integers a and b and outputs something computed using 
    them.  (Notice that the above line is <= 79 characters.)
    """
    c = 0
    
    for i in range(a):
        # add i-th power of b to a and
        # put spaces around operators (comment on line of its own).
        c = b**i + a
        
    # Another block, and a correctly named class (CamelCase).
    class UselessWrapper(int):
        pass
        
    return UselessWrapper(c)
︡65955870-3385-40b3-bb9e-afc3f649dee4︡︡
︠86b0e374-26d8-43a5-af0e-a3d0bd0c52e7︠
n = good_function(2, 5); n
︡d7f18f37-980c-4f48-8fe2-4624d777e61d︡{"stdout": "7"}︡
︠ce54a4b0-2df6-46e7-af9d-cb1f29845603︠
type(n)
︡372e9f13-2e92-4dc8-9e1b-6cb249098ae6︡{"stdout": "<class '__main__.UselessWrapper'>"}︡
︠1a9fd762-fda2-48cb-a447-c3d0f66932dai︠
%html
<p><strong>Aliasing:</strong></p>
<p>From the Python documentation: "Objects have individuality, and multiple names (in multiple scopes) can be bound to the same object. This is known as aliasing in other languages. This is usually not appreciated on a first glance at Python, and can be safely ignored when dealing with immutable basic types (numbers, strings, tuples). However, aliasing has a possibly surprising effect on the semantics of Python code involving mutable objects such as lists, dictionaries, and most other types. This is usually used to the benefit of the program, since aliases behave like pointers in some respects. For example, passing an object is cheap since only a pointer is passed by the implementation; and if a function modifies an object passed as an argument, the caller will see the change &mdash; this eliminates the need for two different argument passing mechanisms as in Pascal."</p>
<p>This is surprising and different than every other language I know. &nbsp;You must understand this point completely, or you'll get seriously tripped up.</p>

<p>Example</p>

︡1c88e492-8b0b-44e5-868d-883145d771b3︡{"html": "<p><strong>Aliasing:</strong></p>\n<p>From the Python documentation: \"Objects have individuality, and multiple names (in multiple scopes) can be bound to the same object. This is known as aliasing in other languages. This is usually not appreciated on a first glance at Python, and can be safely ignored when dealing with immutable basic types (numbers, strings, tuples). However, aliasing has a possibly surprising effect on the semantics of Python code involving mutable objects such as lists, dictionaries, and most other types. This is usually used to the benefit of the program, since aliases behave like pointers in some respects. For example, passing an object is cheap since only a pointer is passed by the implementation; and if a function modifies an object passed as an argument, the caller will see the change &mdash; this eliminates the need for two different argument passing mechanisms as in Pascal.\"</p>\n<p>This is surprising and different than every other language I know. &nbsp;You must understand this point completely, or you'll get seriously tripped up.</p>\n\n<p>Example</p>"}︡
︠c711188f-2842-4b58-aebb-bf2de03d1958︠
v = [1,2,3,10]
︡9662d579-1ff3-49cb-b54d-04838ed10826︡︡
︠b36e3869-9fee-4a9e-bae5-597f1da68298︠
def sum_up(w):
    while len(w) > 1:
        w[-1] += w[0]
        del w[0]
    return w[0]
︡625d2584-8179-4ffc-949a-cecbb14adf74︡︡
︠d496b1df-2487-491b-84ec-a30c77a2dc75︠
sum_up(v)
︡1f0feadc-002d-4903-9bd2-e5d943b498d5︡{"stdout": "16"}︡
︠53a9b8d3-8d37-4201-ab23-8082e6bcdcbf︠
v
︡89144cfa-7bd4-437d-b096-ed4cca0a2d95︡{"stdout": "[16]"}︡
︠db39ba64-2c22-4462-894f-6c0d403ee08fi︠
%html
<p>Hey, what just happened to v?!</p>

︡740eddc6-775a-4824-95cd-0b8ec7f60fd6︡{"html": "<p>Hey, what just happened to v?!</p>"}︡
︠a3aefdbf-cf76-43a0-ab95-35c7ffffdf6f︠
def sum_up(w):
    # make a copy of w:
    w = list(w)
    while len(w) > 1:
        w[-1] += w[0]
        del w[0]
    return w[0]
︡5fa22583-55cb-4d60-8e8a-e49d07fcea93︡︡
︠309a256d-a30e-4859-8774-6ae0bb2dc26b︠
v = [1,2,3,10]
sum_up(v)
︡82153c87-b8de-4f98-9a0c-d07178104f30︡{"stdout": "16"}︡
︠d2687d3c-fcd9-4c42-964d-aa1e3c145cef︠
v
︡c9c0637d-b95f-4978-a1b2-a69774973b51︡{"stdout": "[1, 2, 3, 10]"}︡
︠b7743854-ca32-47b1-b4b1-9098eea9786ci︠
%html
<h1>Classes</h1>

︡20751ac8-ee90-475f-be90-5ddd822df9b3︡{"html": "<h1>Classes</h1>"}︡
︠94ba2a91-4287-48c5-a94b-5b4412242c3e︠
class MyClass:
    """
    A simple example class.
    """
    # a Python object attribute; this is basically a default
    # piece of data that is available to each instance of the
    # class, but can be changed in the instance without changing
    # it in the class.  (See example below.)
    i = 12345
    
    # A function attribute.  Again, this is available to each
    # instance, and can be changed in the instance without
    # changing the class object itself.
    def f(self):
        return 'hello world'
︡ff3b9c7f-8f16-4d67-b1ff-b90dcb0ba847︡︡
︠c0df47c1-c23a-42bf-9a5e-ca6dd95088f3︠
# A class is an object:
MyClass
︡ced04db3-e2fc-4f40-b87f-33c60561881b︡{"stdout": "<class __main__.MyClass at 0x10c917530>"}︡
︠e994a0a3-1251-4ddb-9476-c6630049625f︠
MyClass.i
︡beb4e9a7-c61d-4849-859e-126f2886a7dd︡{"stdout": "12345"}︡
︠0f8ac8a5-8653-40c5-8b30-56468f954b72︠
MyClass.f
︡eafc41c2-7c8a-4454-806f-df78d1c5eec5︡{"stdout": "<unbound method MyClass.f>"}︡
︠3b549cc8-d27e-4d87-9460-8493ace4bd56︠
MyClass.__doc__
︡62fa4064-771d-4d05-9669-2ab5a9c39171︡{"stdout": "'A simple example class'"}︡
︠07a843c7-9fad-453a-91e0-c3b5ad54a17a︠
x = MyClass()
type(x)
︡7121895e-7b23-4772-8beb-64a0126dfe57︡{"stdout": "<type 'instance'>"}︡
︠555997e2-b2d2-4d3a-9a39-bd47f632e4ea︠
x.f()
︡1f90237b-6696-411a-bc97-0097955b185f︡{"stdout": "'hello world'"}︡
︠543f39cf-cf35-40e4-8184-a8446ce7da06︠
x.i
︡9d2e64a5-ebad-41a2-ba5b-8c43317dff5f︡{"stdout": "12345"}︡
︠61a7003d-b55c-4d85-a074-f9081d724666︠
x.i = 100
︡6e789ab4-5171-4ca6-9d51-f5da72522cef︡︡
︠713b6e6f-4a5e-4451-93db-f4b41ce04fce︠
y = MyClass()
y.i
︡518f3de9-5664-4fda-99a3-613f37c30eb3︡{"stdout": "12345"}︡
︠d607238a-eacd-4f35-a0ce-a34db7b50f60︠
MyClass.i = 100
︡ca570899-4834-4df0-a445-040717ccc348︡︡
︠c471beb6-abfa-4d31-ab87-732d9696f445︠
z = MyClass()
z.i
︡5c576f39-41d4-428b-93ec-de113e78d43a︡{"stdout": "100"}︡
︠e1cf4fa0-aee6-454a-b499-7c89d51955a4︠
z.f = lambda : 'goodbye world'
︡bef0e78e-d754-4388-9c77-c4e4befe2b60︡︡
︠9197ffd4-60eb-4d41-85aa-be0c60822687︠
z.f()
︡e6dd82da-2f13-437a-9a4f-18b1d5cb2d07︡{"stdout": "'goodbye world'"}︡
︠fe192a81-2093-442e-ad46-b7307eebb24c︠
x.f()
︡fbd30483-c3b2-475d-a2f7-cf18fc1b5924︡{"stdout": "'hello world'"}︡
︠92252aab-a21b-44e2-9271-d5cdcd591324︠
w = MyClass()
w.f()
︡1c1ec0b9-3e36-40cb-af1b-c538b88e5a21︡{"stdout": "'hello world'"}︡
︠0a884659-ee5b-4342-abf2-12fad3b3a738i︠
%html
<p><strong>Inheritence</strong></p>

︡27c5a95f-742a-4df8-bb84-0d4b2eb4f3f7︡{"html": "<p><strong>Inheritence</strong></p>"}︡
︠94c120d7-e95f-4f86-a71b-c29d552358bb︠
class DerivedClass(MyClass):
    def g(self):
        return "derived class"
    def f(self):
        return "hello *new* world"
︡9d4f48cd-4967-414f-a0e2-cf76fcd5db63︡︡
︠8215bed0-bde1-4e6f-b7c1-6a515bca5e8b︠
d = DerivedClass()
d.g()
︡b3605de7-c602-4c2b-bf44-b96f83a218e8︡{"stdout": "'derived class'"}︡
︠3009f238-7d0c-4d45-b6eb-2d5b48f09912︠
d.f()
︡36dd4053-b9f4-492d-91bf-d484159041a9︡{"stdout": "'hello *new* world'"}︡
︠f08709b4-cbb0-433e-a237-169650be6aea︠
d.i
︡b3901874-e168-4425-ac0b-0847bf635af7︡{"stdout": "12345"}︡
︠5d5d1885-d88b-4f65-8463-fb68c21b3c54i︠
%html
<p><strong>Question: </strong>How do we call the f method defined in the superclass?</p>

<p>One way: explicitly get the superclass's f method, and call it with d as input.</p>

︡94884b84-c477-4e14-a2cb-c67e96d6aa9a︡{"html": "<p><strong>Question: </strong>How do we call the f method defined in the superclass?</p>\n\n<p>One way: explicitly get the superclass's f method, and call it with d as input.</p>"}︡
︠a88b9740-86fe-49b3-ab29-066bb0d4bcc9︠
class DerivedClass(MyClass):
    def g(self):
        return "derived class"
    def f(self):
        return "hello *new* world"
    def s(self):
        return MyClass.f(d)
︡9ab3aca0-be3d-4f99-afb7-a9e58441ea0d︡︡
︠6b3894a8-a56c-452a-9fed-467dbc79a5e7︠
d = DerivedClass()
d.s()
︡b48314a4-d8f8-4de9-8a39-e5fff63e0939︡{"stdout": "'hello world'"}︡
︠1a9e6961-6505-4e40-989d-25d98a904ae8i︠
%html
<p>Approach 2: use the <strong>super</strong> function. &nbsp;This makes no explicit reference to MyClass, which is nice.</p>

︡0b505855-6cc1-482a-9265-07567f9dea40︡{"html": "<p>Approach 2: use the <strong>super</strong> function. &nbsp;This makes no explicit reference to MyClass, which is nice.</p>"}︡
︠eea43aa2-778f-4816-9194-b3af39fda1e8︠
class MyClass:
    i = 12345
    def f(self):
        return 'hello world'
        
class DerivedClass(MyClass):
    def g(self):
        return "derived class"
    def f(self):
        return "hello *new* world"
    def s(self):
        return super(DerivedClass, self).f()
︡d3894ddf-d3c9-44a6-9365-49a89ed898f8︡︡
︠160f5405-9fb9-41cb-859c-046d0dc74a4d︠
d = DerivedClass()
d.s()
︡7fd9f258-1ab5-4dac-989f-3592d663d4b4︡{"stderr": "Traceback (most recent call last):\n  File \"<stdin>\", line 1, in <module>\n  File \"_sage_input_92.py\", line 10, in <module>\n    exec compile(u\"print _support_.syseval(python, u'd = DerivedClass()\\\\nd.s()', __SAGE_TMP_DIR__)\" + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"/Users/wstein/sage/install/sage-4.5.3/local/lib/python2.6/site-packages/sagenb-0.8.2-py2.6.egg/sagenb/misc/support.py\", line 473, in syseval\n    return system.eval(cmd, sage_globals, locals = sage_globals)\n  File \"/Users/wstein/sage/install/sage-4.5.3/local/lib/python2.6/site-packages/sage/misc/python.py\", line 56, in eval\n    eval(z, globals)\n  File \"\", line 1, in <module>\n    \n  File \"\", line 13, in s\n    \nTypeError: super() argument 1 must be type, not classobj"}︡
︠8a7e4539-a00d-47b3-bcbf-7666b27ec7cei︠
%html
<p>Huh!? &nbsp;See h<a href="ttp://stackoverflow.com/questions/489269/python-super-raises-typeerror-why" target="_blank">ttp://stackoverflow.com/questions/489269/python-super-raises-typeerror-why</a>. &nbsp;The problem is that super only operators on <em>new style classes</em>, i.e., classes that derive from <strong>object</strong>. &nbsp; (Note: In Python 3.x, <em>all classes</em>&nbsp;are new style classes.)</p>

︡4eeef237-4888-47b9-93ee-513a7721ace2︡{"html": "<p>Huh!? &nbsp;See h<a href=\"ttp://stackoverflow.com/questions/489269/python-super-raises-typeerror-why\" target=\"_blank\">ttp://stackoverflow.com/questions/489269/python-super-raises-typeerror-why</a>. &nbsp;The problem is that super only operators on <em>new style classes</em>, i.e., classes that derive from <strong>object</strong>. &nbsp; (Note: In Python 3.x, <em>all classes</em>&nbsp;are new style classes.)</p>"}︡
︠823d860a-3dd8-4eac-83eb-26ae34a96b09︠
class MyClass(object):
    i = 12345
    def f(self):
        return 'hello world'
        
class DerivedClass(MyClass):
    def g(self):
        return "derived class"
    def f(self):
        return "hello *new* world"
    def s(self):
        # no explicit reference to MyClass here.
        return super(DerivedClass, self).f()
︡a3923963-9828-4ff1-a152-0370e7462ad0︡︡
︠1aace9ad-bf65-4160-b0a1-cc21cadec5f0︠
d = DerivedClass()
d.s()
︡84d0b623-5370-4dea-b514-f3c30bd48565︡{"stdout": "'hello world'"}︡
︠3f5dd0c5-52f3-43b4-92a3-aec4ccf5d121i︠
%html
<p><strong>Multiple Inheritence: new versus old style classes</strong></p>
<pre style="font-size: 14px; background-color: #e0e0ff; padding: 10px;"> -----------
|           |
|    O      |
|  /   \    |
 - X    Y  /
   |  / | /
   | /  |/
   A    B
   \   /
     C</pre>

<p>Old style classes -- allow ambiguous class&nbsp;hierarchies:</p>

︡a734759f-f990-4525-b288-8c2869b7263f︡{"html": "<p><strong>Multiple Inheritence: new versus old style classes</strong></p>\n<pre style=\"font-size: 14px; background-color: #e0e0ff; padding: 10px;\"> -----------\n|           |\n|    O      |\n|  /   \\    |\n - X    Y  /\n   |  / | /\n   | /  |/\n   A    B\n   \\   /\n     C</pre>\n\n<p>Old style classes -- allow ambiguous class&nbsp;hierarchies:</p>"}︡
︠91887d6c-e538-49b0-a9de-5dca8fef2449︠
class O: pass
class X(O): pass
class Y(O): pass
class A(X,Y): pass
class B(Y,X): pass
class C(A,B): pass
︡a976cd4e-fdca-4aca-9fcc-4730e6016e3d︡︡
︠8457d923-a834-4928-8700-7a37031c99cai︠
%html
<p>New style classes don't allow this:</p>

︡68f14bea-ab49-4d22-a61a-053fa8f3971b︡{"html": "<p>New style classes don't allow this:</p>"}︡
︠82e2613e-6046-47d1-b29a-ad405be5cc8c︠
O = object
class X(O): pass
class Y(O): pass
class A(X,Y): pass
class B(Y,X): pass
class C(A,B): pass
︡71d87ad1-e6a6-4765-9318-8ff706678b91︡{"stderr": "Traceback (most recent call last):\n  File \"<stdin>\", line 1, in <module>\n  File \"_sage_input_126.py\", line 10, in <module>\n    exec compile(u\"print _support_.syseval(python, u'O = object\\\\nclass X(O): pass\\\\nclass Y(O): pass\\\\nclass A(X,Y): pass\\\\nclass B(Y,X): pass\\\\nclass C(A,B): pass', __SAGE_TMP_DIR__)\" + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"/Users/wstein/sage/install/sage-4.5.3/local/lib/python2.6/site-packages/sagenb-0.8.2-py2.6.egg/sagenb/misc/support.py\", line 473, in syseval\n    return system.eval(cmd, sage_globals, locals = sage_globals)\n  File \"/Users/wstein/sage/install/sage-4.5.3/local/lib/python2.6/site-packages/sage/misc/python.py\", line 56, in eval\n    eval(z, globals)\n  File \"\", line 1, in <module>\n    \nTypeError: Error when calling the metaclass bases\n    Cannot create a consistent method resolution\norder (MRO) for bases X, Y"}︡
︠7b75635f-756f-4818-9025-cec26a74278fi︠
%html
<p><strong>Method Resolution Order:&nbsp;</strong></p>
<p>Given any Python class C, there is a linearly ordered list of the superclasses of C that Python computes, called the MRO "Method Resolution Order". &nbsp;When you try to call a function of (an instance of) C, Python just checks for that function in each of the methods of the classes in the MRO, <em>in order.</em></p>
<ol>
<li>Different for old and new style classes. &nbsp;Old style classes have a very easy MRO, &nbsp;but it has quite bad theoretical properties. &nbsp;"For old-style classes, the only rule is depth-first, left-to-right."</li>
<li>For new style classes see <a href="http://www.python.org/download/releases/2.3/mro/" target="_blank">http://www.python.org/download/releases/2.3/mro/</a>&nbsp;for a detailed discussion on the new style MRO.</li>
<li>Fortunately, you can simply <em>ask a new style class</em>&nbsp;for its MRO. &nbsp;When in doubt, just do this. &nbsp;</li>
</ol>

︡2d74aba1-6141-4017-bd76-c20f020fc76c︡{"html": "<p><strong>Method Resolution Order:&nbsp;</strong></p>\n<p>Given any Python class C, there is a linearly ordered list of the superclasses of C that Python computes, called the MRO \"Method Resolution Order\". &nbsp;When you try to call a function of (an instance of) C, Python just checks for that function in each of the methods of the classes in the MRO, <em>in order.</em></p>\n<ol>\n<li>Different for old and new style classes. &nbsp;Old style classes have a very easy MRO, &nbsp;but it has quite bad theoretical properties. &nbsp;\"For old-style classes, the only rule is depth-first, left-to-right.\"</li>\n<li>For new style classes see <a href=\"http://www.python.org/download/releases/2.3/mro/\" target=\"_blank\">http://www.python.org/download/releases/2.3/mro/</a>&nbsp;for a detailed discussion on the new style MRO.</li>\n<li>Fortunately, you can simply <em>ask a new style class</em>&nbsp;for its MRO. &nbsp;When in doubt, just do this. &nbsp;</li>\n</ol>"}︡
︠db008b50-5533-486c-8df6-94f7c3ef8176︠
O = object
class X(O): pass
class Y(O): pass
class A(X,Y): pass
class B(Y,X): pass
A.mro()
︡63afbac3-c227-49f7-8d0d-66f9883c3865︡{"stdout": "[<class '__main__.A'>, <class '__main__.X'>, <class '__main__.Y'>, <type 'object'>]"}︡
︠b3083a70-d8c9-41cc-88d3-32e1051bbf1d︠
B.mro()
︡c918cfd3-cd59-4059-9676-81fb31eabdea︡{"stdout": "[<class '__main__.B'>, <class '__main__.Y'>, <class '__main__.X'>, <type 'object'>]"}︡
︠d3b5332e-1c6f-40c7-a6c0-6936b55a7ac5i︠
%html
<p>Another:</p>
<pre style="font-size: 14px; background-color: #e0e0ff; padding: 10px;">                           6
                          ---
Level 3                  | O |
                       /  ---  \
                      /    |    \
                     /     |     \
                    /      |      \
                  ---     ---    ---
Level 2        2 | E | 4 | D |  | F | 5
                  ---     ---    ---
                   \      / \     /
                    \    /   \   /
                     \  /     \ /
                      ---     ---
Level 1            1 | B |   | C | 3
                      ---     ---
                       \       /
                        \     /
                          ---
Level 0                0 | A |
                          ---</pre>

︡48dd4a37-b689-4ac1-9290-57d2742e737d︡{"html": "<p>Another:</p>\n<pre style=\"font-size: 14px; background-color: #e0e0ff; padding: 10px;\">                           6\n                          ---\nLevel 3                  | O |\n                       /  ---  \\\n                      /    |    \\\n                     /     |     \\\n                    /      |      \\\n                  ---     ---    ---\nLevel 2        2 | E | 4 | D |  | F | 5\n                  ---     ---    ---\n                   \\      / \\     /\n                    \\    /   \\   /\n                     \\  /     \\ /\n                      ---     ---\nLevel 1            1 | B |   | C | 3\n                      ---     ---\n                       \\       /\n                        \\     /\n                          ---\nLevel 0                0 | A |\n                          ---</pre>"}︡
︠31943263-3ab0-4a52-9f51-64b7fdc441da︠
O = object
class F(O): pass
class E(O): pass
class D(O): pass
class C(D,F): pass
class B(E,D): pass
class A(B,C): pass
︡6e9559a2-f18e-43a4-8c0f-611db9d238c8︡︡
︠6cdd0ce7-f442-44b2-b496-fdad50012179︠
A.mro()
︡0042d6b0-4f49-4b31-84c3-5b5dd2c5aa19︡{"stdout": "[<class '__main__.A'>, <class '__main__.B'>, <class '__main__.E'>, <class '__main__.C'>, <class '__main__.D'>, <class '__main__.F'>, <type 'object'>]"}︡
︠b86c6b72-15bb-4e5f-b177-a254c8a8de3ei︠
%html
<p><strong>Private Variables.</strong></p>
<p>This is done in Python via "mangling".</p>

︡e7608402-be34-4578-bb4c-051d1468e9bf︡{"html": "<p><strong>Private Variables.</strong></p>\n<p>This is done in Python via \"mangling\".</p>"}︡
︠e04049bd-030e-4932-b3a2-34dd4a4a0a21︠
class MyOwnClass(object):
    def __init__(self):
        self.__secret_number = 10
    def __repr__(self):
        return str(self.__secret_number)
︡b79fd7d4-a8df-499c-959f-a6f3cc8a1fb6︡︡
︠f3247ce3-fa2d-419f-88b5-ac92458acee8︠
x = MyOwnClass()
x
︡897dd26c-4b8e-4248-b99d-58a2fbfe0e57︡{"stdout": "10"}︡
︠20210b47-0e88-4d3d-a00a-1f43f84ff649︠
x.__secret_number = 20
︡cf03d35b-7f36-4188-b86f-3420ad8f425f︡︡
︠77ad6786-f623-41b2-8573-339df284638c︠
x
︡8fcd894e-74a6-4cd0-8e01-73b940864581︡{"stdout": "10"}︡
︠fc00b85e-6133-4c16-a923-74c2c7e433aa︠
x.__dict__
︡7530f284-311e-44d9-9e5b-4f5d0dc3f14b︡{"stdout": "{'__secret_number': 20, '_MyOwnClass__secret_number': 10}"}︡
︠1266f45d-41bf-46b1-bff4-b7d5156e5186i︠
%html
<p>Easily thwarted:</p>

︡7b86fd27-4fe9-4f01-95ac-f64bcf4a8cdc︡{"html": "<p>Easily thwarted:</p>"}︡
︠b0bf5ebf-8c6e-439d-82f0-b056d5204e3d︠
x._MyOwnClass__secret_number = 20
︡5dd88923-6999-420b-b8a9-e8d50023c7b5︡︡
︠ff83694c-1c8a-474e-9b1f-5216311e0b2d︠
x
︡37ba55c5-ecfe-41b4-a577-2c905786809f︡{"stdout": "20"}︡
︠1ea9030b-b509-4afd-94c0-652dcdfa17d0i︠
%html
<p>From experience I can tell you most people <em>really hate</em>&nbsp;the use of these mangled private variables. &nbsp;It is much better to just use a single underscore, which is meant as a convention <em>"However, there is a convention that is followed by most Python code: a name prefixed with an underscore (e.g.&nbsp;</em><tt style="background-color: #ecf0f3; padding-top: 0px; padding-right: 1px; padding-bottom: 0px; padding-left: 1px; font-size: 0.95em;"><span><em>_spam</em></span></tt><em>) should be treated as a non-public part of the API (whether it is a function, a method or a data member). It should be considered an implementation detail and subject to change without notice."</em></p>

︡149ccfd3-741d-4719-a735-aac8bab1199d︡{"html": "<p>From experience I can tell you most people <em>really hate</em>&nbsp;the use of these mangled private variables. &nbsp;It is much better to just use a single underscore, which is meant as a convention <em>\"However, there is a convention that is followed by most Python code: a name prefixed with an underscore (e.g.&nbsp;</em><tt style=\"background-color: #ecf0f3; padding-top: 0px; padding-right: 1px; padding-bottom: 0px; padding-left: 1px; font-size: 0.95em;\"><span><em>_spam</em></span></tt><em>) should be treated as a non-public part of the API (whether it is a function, a method or a data member). It should be considered an implementation detail and subject to change without notice.\"</em></p>"}︡
︠0659c397-602d-42ae-a56b-7313c0a8f7e9︠
class MyOwnClass(object):
    def __init__(self):
        self._confidential_number = 10
    def __repr__(self):
        return str(self._confidential_number)
︡f8b6f592-246a-4ae2-bac1-1bdd2151c90b︡︡
︠7f64a1cc-ef92-4151-85d6-8466b51ebc4e︠
x = MyOwnClass(); x
︡94b63a65-e7fd-4e58-be09-47f5d29146f9︡{"stdout": "10"}︡
︠5260d9d2-c277-4ed7-af65-896bd42208dd︠
x._confidential_number = 20
x
︡b07d83bc-b096-4762-92be-62160875474f︡{"stdout": "20"}︡
